;Wild Ptooie Pirhana
;by smkdan

;DOESN'T USE EXTRA BIT

;Tilemaps for SP4

DIR = $03
PROPRAM = $04
PROPINDEX = $05
XDISPINDEX = $06
PRIINDEX = $07
FRAMEINDEX = $08
TEMP = $09

;20,18,10

ACTION	dcb $01,$02,$03,$00,$00,$00,$00		;long, middle, short, nothing: face mario, stare , look back
	dcb $00,$00					;struck behaviour

COUNT	dcb $40,$40,$20,$20,$20,$30,$20		;count for different stages
	dcb $30,$20					;struck counter

PALETTE	dcb $00,$04,$08
EORTBL	dcb $00,$FF
INCDEC	dcb $00,$01

;===

;Set this to each of the three launch speeds
XSPD	dcb $20,$18,$10

;Same deal, for Y speed
YSPD	dcb $40,$40,$40

;Set this to number needlenose bomb is inserted as
SPRITE_NUM = $01

;Set this to sound you want it to make when it shoots
SHOOT_SOUND = $3A

;1602: Shoot counter
;C2: Shoot behaviour
;1570: hit counter

dcb "INIT"
	JSR SUB_HORZ_POS
	TYA
	STA $157C,x		;make it face mario initially

	LDA #$03		;doing nothing initially
	STA $C2,x
	RTL

dcb "MAIN"
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL	;also nothing


Return_I
	RTS

Run
	JSR SUB_OFF_SCREEN_HB
	JSR GET_DRAW_INFO
	JSR GFX

	LDA $14C8,x
	CMP #$08            	 
	BNE Return_I           
	LDA $9D			;locked sprites?
	BNE Return_I
	LDA $15D0,x		;being eaten by yoshi?
	BNE Return_I

	JSR SUB_HORZ_POS	;TEMP: always facing Mario
	TYA
	STA $157C,x

	JSR CheckHurt		;see if a shell or throw block is making contact
	BEQ NoContact		;zero on not contact, continue as normal

	LDA #$07		;behaviour is set to 'struck'
	STA $C2,x
	STZ $1602,x		;reset counter

;HURT HANDLER

NoContact
	LDA $C2,x		;check if it's past hurt
	CMP #$08
	BNE AdvCounter

	LDA $1570,x		;load hurt counter
	CMP #$02		;dead?
	BNE NotDeadYet

	JSR SUB_SMOKE		;make smoke

	LDA $D8,x
	CLC
	ADC #$04
	STA $D8,x
	LDA $14D4,x
	ADC #$00		;transfer carry
	STA $14D4,x

	LDA $E4,x
	CLC
	ADC #$09
	STA $E4,x
	LDA $14E0,x
	ADC #$00		;transfer carry
	STA $14E0,x

	JSL $07FC3B		;make stars
	STZ $14C8,x		;erase sprite

	LDA #$49
	STA $1DFC		;higher pitch
	
	JMP Return		;return
	

NotDeadYet
	LDA #$03		;when counter expires, set it back to normal status
	STA $C2,x
	STZ $1602,x		;reset counter

	INC $1570,x		;TEMP: increment hurt counter
	LDY $1570,x		;load hit counter as index

	LDA $15F6,x		;palette, page bit
	AND #$F1		;clip pal bits
	ORA PALETTE,y
	STA $15F6,x		;new GFX bits
			
;SHOOTING / BEHAVIOUR CODE
AdvCounter	
	INC $1602,x		;advance counter
	LDA $1602,x
	LDY $C2,x
	CMP COUNT,y		;different counter for different behaviour stage
	BCC NoGen		;if count not yet reached, check for generate

;advance behaviour since count was reached

	LDA $C2,x		;load shooting behaviour...
	INC A
	CMP #$07		;7 variables
	BNE DontClipVar
	LDA #$00		;reset shooting behaviour

DontClipVar
	STA $C2,x		;...new shooting behaviour
	LDY $C2,x		;load new behaviour

	STZ $1602,x		;also zero counter

	LDA ACTION,y		;load speed/control, C2 already in Y for index
	BEQ NoGen		;if zero, skip generating TEMP
	DEC A			;-1, for index since 00 does nothing		
	STA TEMP		;store loaded speed to generate

	JSR GenCust		;generate if counted

NoGen	
	JSL $01802A		;speed update
	JSL $01A7DC		;mario interact

Return
	RTS	

;===

GenCust
	JSL $02A9E4		;grab free sprite slot
	BMI ReturnG		;return if none left before anything else...

	JSR SetupCust

ReturnG
	RTS			;return custom

SetupCust
	PHX			;preserve sprite index

	LDA #$01
	STA $14C8,y		;normal status, run init routine?

	LDA #SPRITE_NUM		;load sprite number to generate

	PHX
	TYX
	STA $7FAB9E,x		;into sprite type table for custom sprites
	PLX

	LDA $157C,x		;test direction
	BNE GoingLeft
	LDA #$18		;base X starts more to the right if facing right

GoingLeft	
	CLC
	ADC $E4,x		;add X pos to base X
	STA $E4,y
	LDA $14E0,x		;share same screen
	ADC #$00		;transfer carry
	STA $14E0,y

	LDA $D8,x
	SEC
	SBC #$0C		;TEMP: change gen position based on direction
	STA $D8,y		;Ypos
	LDA $14D4,x
	SBC #$00
	STA $14D4,y		;same screen

	TYX			;new sprite slot into X
	JSL $07F7D2		;create sprite
	JSL $0187A7
        LDA #$88		;set as custom sprite
        STA $7FAB10,X

	LDY TEMP		;load index for speeds
	LDA XSPD,y

	PHY
	PHX
	LDX $15E9
	LDY $157C,x		;load plant direction...
	EOR EORTBL,y		;invert as needed
	CLC
	ADC INCDEC,y		;adjust for two's complement
	PLX
	PLY

	STA $B6,x		;set Xspd

	LDA YSPD,y		;negative on rising, just easier to manage
	EOR #$FF
	INC A			;two's complement
	STA $AA,x		;set Yspd

	LDA #SHOOT_SOUND	;play shooting sound
	STA $1DFC

	PLX			;restore sprite index

	RTS			;return

;damage check routine

CheckHurt
	LDY #$0B		;loop count

CheckLoop
	LDA $14C8,Y		;sprite status
	CMP #$09
	BNE CheckKick
	BRA ClipTest		;jump to cliptest
	
CheckKick
	CMP #$0A		;sprites never have normal status
	BNE NextSprite

	LDA $1686,Y		;skip sprites that don't interact with others
	AND #$08
	BNE NextSprite

ClipTest
	JSL $03B69F	;clipA
	PHX
	TYX
	JSL $03B6E5	;clipB
	PLX
	JSL $03B72B	;check contact between A and B
	BCC NextSprite	;no contact = don't set

	LDA #$01	;set test variable...

	PHX

;adjust position for stars

	LDA $D8,x
	PHA
	CLC
	ADC #$04
	STA $D8,x
	LDA $14D4,x
	PHA
	ADC #$00		;transfer carry
	STA $14D4,x

	LDA $E4,x
	PHA
	CLC
	ADC #$09
	STA $E4,x
	LDA $14E0,x
	PHA
	ADC #$00		;transfer carry
	STA $14E0,x

	PHY
	JSL $07FC3B	;create stars
	PLY

;fix position

	PLA
	STA $14E0,x
	PLA
	STA $E4,x

	PLA
	STA $14D4,x
	PLA
	STA $D8,x

	LDA #$47	;enemy hit sound
	STA $1DFC

	TYX
	STZ $14C8,x	;erase sprite

	PLX

	RTS		;...and return

NextSprite	
        DEY
	BPL CheckLoop

	LDA #$00
	RTS		;last return

;smoke routine on exploding

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE1           LDA $17C0,y             ;  |
                    BEQ FOUNDONE1            ;  |
                    DEY                     ;  |
                    BPL FINDFREE1            ;  |
                    RTS                     ; / return if no slots open

FOUNDONE1           LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x               ; \ smoke y position = generator y position
                    CLC
                    ADC #$04
                    STA $17C4,y             ; /
                    LDA #$14                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x               ; \ load generator x position and store it for later
		    CLC
		    ADC #$F8
                    STA $17C8,y             ; /
                    LDX $15E9 

                    LDY #$03                ; \ find a free slot to display effect
FINDFREE2           LDA $17C0,y             ;  |
                    BEQ FOUNDONE2            ;  |
                    DEY                     ;  |
                    BPL FINDFREE2            ;  |
                    RTS                     ; / return if no slots open

FOUNDONE2           LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x               ; \ smoke y position = generator y position
                    CLC
                    ADC #$04
                    STA $17C4,y             ; /
                    LDA #$14                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x               ; \ load generator x position and store it for later
		    CLC
		    ADC #$18
                    STA $17C8,y             ; /
                    LDX $15E9
             
                    RTS
;GFX
;===

TILEMAP	dcb $8C,$8E		;open mouth shooting frames
	dcb $AC,$AE
	dcb $C0			;the stem

;...
	dcb $80,$82		;closed mouth shooting frames
	dcb $A0,$A2
	dcb $C0

	dcb $84,$86		;closed mouth tilt frames
	dcb $A4,$A6
	dcb $C0

	dcb $88,$8A		;closed mouth horz frames
	dcb $A8,$AA
	dcb $C0

;...

XDISP	dcb $00,$10
	dcb $00,$10
	dcb $10

YDISP	dcb $F8,$F8
	dcb $08,$08
	dcb $10

XBIAS	dcb $18,$18
	dcb $18,$18
	dcb $20

PROP	dcb $00,$00
	dcb $00,$00
	dcb $40

CPAL	dcb $00,$00
	dcb $00,$00
	dcb $03			;the stem is green

EORF	dcb $40,$00

PALETTEB	dcb $02,$04,$03		;yellow, red, blue
		dcb $05,$02,$04		;green, yellow

Flinch
	LDA #$0E		;reset palette bits
	TRB PROPRAM
	
	LDA $1602,x		;counter...
	LSR A
	LSR A			;every 4th tick
	AND #$01
	BNE CustomPal

	PHY
	LDY $1570,x		;hit count
	LDA PALETTEB,y		;load appropriate bit
	PLY
	ASL A			;into palette bits
	TSB PROPRAM		;set palette bits

	JMP ClosedMouth
	
CustomPal	
	PHY
	LDY $1570,x		;hit count
	INY
	INY
	INY			;2 bytes for each
	LDA PALETTEB,y		;load appropriate bit
	PLY
	ASL A			;into palette bits
	TSB PROPRAM		;set palette bits
	JMP ClosedMouth

;===
	
GFX
	LDA $157C,x
	STA DIR			;convenient

	LDA $15F6,x
	STA PROPRAM

	STZ FRAMEINDEX		;reset frame index

;check special cases first

	LDA $C2,x		;load shooting behaviour...

	CMP #$03
	BEQ ClosedMouth		;nothing for a bit...

	CMP #$04		;...then look down
	BEQ LookMario

	CMP #$05
	BEQ JustLook

	CMP #$06
	BEQ LookUp		;...then look up

	CMP #$07
	BEQ Flinch		;struck = flick back and flash

	CMP #$08
	BEQ ClosedMouth

;normal shooting
	LDA $1602,x		;loading shooting frame counter...
	AND #$30		;2 high bits of counter
	CMP #$10		;compare high bits, since mouth should only be open for a bit
	BCS ClosedMouth

	BRA SkipClose		;bottom out on skipclose

LookMario
	LDA $1602,x		;counter
	AND #$18		;2 high bits
	CMP #$18
	BNE DontClipLM		;if not equal to max, do nothing
	AND #$10		;snip off lower bit	

DontClipLM	
	LSR A			;>> 3
	LSR A
	LSR A

	STA TEMP		;temp storage	
	ASL A			;x2
	ASL A			;x4
	CLC
	ADC TEMP		;x5
	ADC #$05		;skip past shoot frame
	STA FRAMEINDEX		;new frame index
		
	BRA SkipClose		;bottom out on open

;===

LookUp
	LDA $1602,x		;counter
	EOR #$18		;invert bits, 'counting down'

	AND #$18		;2 high bits
	CMP #$18
	BNE DontClipLU		;if not equal to max, do nothing
	AND #$10		;snip off lower bit	

DontClipLU
	LSR A			;>> 3
	LSR A
	LSR A

	STA TEMP		;temp storage	
	ASL A			;x2
	ASL A			;x4
	CLC
	ADC TEMP		;x5
	ADC #$05		;skip past shoot frame
	STA FRAMEINDEX		;new frame index
		
	BRA SkipClose		;bottom out on open

;===

JustLook
	LDA #$0F		;TEMP: just horziontal frame
	STA FRAMEINDEX

	BRA SkipClose
	
ClosedMouth
	LDA #$05		;load mouth frames
	STA FRAMEINDEX		;new frame index

SkipClose	
	LDX #$00		;reset loop index

OAM_LOOP
	LDA DIR
	BNE XLeft

	LDA $00
	SEC
	SBC XDISP,x
	CLC
	ADC XBIAS,x		;add bias since it throws it on the other side
	STA $0300,y
	BRA XNext
XLeft
	LDA $00
	CLC
	ADC XDISP,x
	STA $0300,y
XNext

	LDA $01
	CLC
	ADC YDISP,x
	STA $0301,y


	TXA	
	CLC
	ADC FRAMEINDEX
	PHX
	TAX
	LDA TILEMAP,x
	STA $0302,y
	PLX

	TXA	
	CLC
	ADC FRAMEINDEX
	PHX
	TAX
	LDA $64
	PHX
	LDX DIR
	EOR EORF,x
	PLX
	PLX

	ORA PROP,x	;use loop index for the properties

	STA TEMP	;store current value to TEMP
	LDA CPAL,x
	BEQ CustomPalB	;if zero, use user supplied palette

	ASL A		;else move into palette bits
	TSB TEMP	;OR with current bits
	LDA PROPRAM
	AND #$01	;load only the low bit, page bit
	TSB TEMP	;OR with current bits
	LDA TEMP	;get ready to store it

	BRA StoreProp	;skip past custom palette bit
	
CustomPalB
	LDA #$00	;reset		
	LDA PROPRAM	;just OR with propram
	ORA TEMP	;and also TEMP

StoreProp
	STA $0303,y

	INY
	INY
	INY
	INY
	INX
	CPX #$05	;5 tiles
	BNE OAM_Loop

	LDX $15E9		;restore sprite index

	LDY #$02		;16x16 tiles
	LDA #$04		;5 tiles
	JSL $01B7B3
	
	RTS

;=================
;BORROWED ROUTINES
;=================

;GET_DRAW_INFO
;==============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
	

;SUB_OFF_SCREEN
;==============

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | 
SUB_OFF_SCREEN_X1   LDA #$04                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X2   LDA #$02                ;  |
STORE_03            STA $03                 ;  |
                    BRA START_SUB           ;  |
SUB_OFF_SCREEN_HB   STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ;  |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ;  | 
                    ADC #$50                ;  | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ;  | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ;  | 
                    CMP #$02                ;  | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ;  | 
                    ORA $03                 ;  | 
                    STA $01                 ;  |
                    TAY                     ; /
                    LDA $1A                 ;x boundry ;A:0101 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0256 VC:090 00 FL:16953
                    CLC                     ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0280 VC:090 00 FL:16953
                    ADC TABLE4,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0294 VC:090 00 FL:16953
                    ROL $00                 ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0326 VC:090 00 FL:16953
                    CMP $E4,x               ;x pos ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0364 VC:090 00 FL:16953
                    PHP                     ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0394 VC:090 00 FL:16953
                    LDA $1B                 ;x boundry hi ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizCHC:0416 VC:090 00 FL:16953
                    LSR $00                 ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0440 VC:090 00 FL:16953
                    ADC TABLE5,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdizcHC:0478 VC:090 00 FL:16953
                    PLP                     ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizcHC:0510 VC:090 00 FL:16953
                    SBC $14E0,x             ;x pos high ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0538 VC:090 00 FL:16953
                    STA $00                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0570 VC:090 00 FL:16953
                    LSR $01                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0594 VC:090 00 FL:16953
                    BCC LABEL20             ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0632 VC:090 00 FL:16953
                    EOR #$80                ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0648 VC:090 00 FL:16953
                    STA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0664 VC:090 00 FL:16953
LABEL20             LDA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0688 VC:090 00 FL:16953
                    BPL RETURN_2            ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0712 VC:090 00 FL:16953
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ;  |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x             ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0140 VC:071 00 FL:21152
                    CPY #$FF                ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0172 VC:071 00 FL:21152
                    BEQ KILL_SPRITE         ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0188 VC:071 00 FL:21152
                    LDA #$00                ; \ mark sprite to come back    A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0204 VC:071 00 FL:21152
                    STA $1938,y             ; /                             A:FF00 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0220 VC:071 00 FL:21152
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ;  | 
                    BCS RETURN_2            ; /
                    AND #$01                ;A:0227 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0228 VC:112 00 FL:1142
                    STA $01                 ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0244 VC:112 00 FL:1142
                    TAY                     ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0268 VC:112 00 FL:1142
                    LDA $1C                 ;A:0201 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0282 VC:112 00 FL:1142
                    CLC                     ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0306 VC:112 00 FL:1142
                    ADC TABLE3,y            ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0320 VC:112 00 FL:1142
                    ROL $00                 ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0352 VC:112 00 FL:1142
                    CMP $D8,x               ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0390 VC:112 00 FL:1142
                    PHP                     ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0420 VC:112 00 FL:1142
                    LDA.W $001D             ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNVMXdizcHC:0442 VC:112 00 FL:1142
                    LSR $00                 ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdiZcHC:0474 VC:112 00 FL:1142
                    ADC TABLE6,y            ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdizCHC:0512 VC:112 00 FL:1142
                    PLP                     ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0544 VC:112 00 FL:1142
                    SBC $14D4,x             ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0572 VC:112 00 FL:1142
                    STA $00                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0604 VC:112 00 FL:1142
                    LDY $01                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0628 VC:112 00 FL:1142
                    BEQ LABEL22             ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0652 VC:112 00 FL:1142
                    EOR #$80                ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0668 VC:112 00 FL:1142
                    STA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0684 VC:112 00 FL:1142
LABEL22             LDA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0708 VC:112 00 FL:1142
                    BPL RETURN_2            ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0732 VC:112 00 FL:1142
                    BMI ERASE_SPRITE        ;A:0280 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0170 VC:064 00 FL:1195

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ;  |  
                    RTS                     ; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00
			LDA $94
			SEC
			SBC $E4,x
			STA $0F
			LDA $95
			SBC $14E0,x
			BPL SPR_L16
			INY
SPR_L16			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B829 

SUB_VERT_POS        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11             RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924    